﻿version
6.50
-1
2
Thread:Thread
BasicLib:BasicLib
Sub designer
end sub
@EndOfDesignText@
'version: 1.1
Sub Globals
	'Declare the global variables here.
#Region Publics

	Public SubModule
	SubModule = "" ' used as the module prefix for alll script Subs

	Public MessageSub ' called by MsgBox in a script
	MessageSub = "" ' takes two  parameters (message, title)
	
	Public EndedSub 
	EndedSub = "" ' parameter(error, errordata) : no return 	
	
	Public Args(0) ' passed as arguments to a script when it is run
	
	Public DataArray(0) ' must be set by GetHostArraySub and read by SetHostArraySub
 	Public GetArraySub
	GetArraySub = "" ' parameter(HostArrayName) : no return 	
 	Public SetArraySub
	SetArraySub = "" ' parameter(HostArrayName)) : no return 
	
	Public DataVariable ' must be set by GetHostVariableSub and read by SetHostVariableSub
 	Public GetVariableSub
	GetVariableSub = "" ' parameter(HostVariableName) : no return 	
 	Public SetVariableSub
	SetVariableSub = "" ' parameter(HostVariableName) : no return 
	
#End Region 
	Dim OnThread ' true if script running on a separate thread
	Dim CallHostData(0) ' used to parse CallHost data
	BasicLib.New1
	Thread.New1(B4PObject(1))
	Public Executing
	Executing = False
End Sub

#Region Subs that are public

Public Sub Run(Script, runonthread)
	If Executing Then ' prevent disturbing it while its running
		Return
	End If
	OnThread = runonthread
	If BasicLib.LoadCodeAsString(Script) Then
		If runonthread Then
			Thread.Start("Script.RunThread")
		Else
			BasicLib.Run(Args())
		End If
	Else
		BasicLib_Ended
	End If
End Sub

#End Region

Sub RunThread
	' need to wrap the thread start as parameters can't be passed to a thread
  Executing = True
	BasicLib.Run(Args()) 
	Executing = False
End Sub


' CallHost("FileRead", "SrcPath,DestScriptVarName")
Sub HostFileRead
	FileOpen(file, AppPath & "\" & CallHostData(0), cRead)
	data = FileReadToEnd(file)
	FileClose(file)
	BasicLib.SetGlobal(CallHostData(1), data)
End Sub

' CallHost("FileWrite", "DestPath,SrcScriptVarName")
Sub HostFileWrite
	data = BasicLib.GetGlobal(CallHostData(1))
	FileOpen(file, AppPath & "\" & CallHostData(0), cWrite)
	FileWrite(file, data )
	FileClose(file)
End Sub

' CallHost("FileDel", "DestPath")
Sub HostFileDel
	FileDel(AppPath & "\" & CallHostData(0))
End Sub

' CallHost("FileExist", "DestPath,DestScriptArrayName")
Sub HostFileExist
	exists = FileExist(AppPath & "\" & CallHostData(0))
	BasicLib.SetGlobal(CallHostData(1), exists)
End Sub

' CallHost("DirCreate", "DestPath,SrcScriptVarName")
Sub HostDirCreate
	DirCreate(AppPath & "\" & CallHostData(0))
End Sub

' CallHost("DirDel", "DestPath")
Sub HostDirDel
	DirDel(AppPath & "\" & CallHostData(0), True)
End Sub

' CallHost("DirExist", "DestPath,DestScriptVarName")
Sub HostDirExist
	exists = DirExist(AppPath & "\" & CallHostData(0))
	BasicLib.SetGlobal(CallHostData(1), exists)
End Sub

' CallHost("GetArray", "SrcHostArrayName,DestScriptArrayName")
Sub GetArray
	CallSub(SubModule & "." & GetArraySub, CallHostData(0))
	BasicLib.SetArray(CallHostData(1), DataArray())
End Sub

' CallHost("SetArray", "DestHostArrayName,SrcScriptArrayName")
Sub SetArray
	DataArray() = BasicLib.GetArray(CallHostData(1))
	CallSub(SubModule & "." & SetArraySub, CallHostData(0))
End Sub

'   CallHost("GetVariable", "SrcHostVarName,DestScriptVarName")
Sub GetVariable
	CallSub(SubModule & "." & GetVariableSub, CallHostData(0))
	BasicLib.SetGlobal(CallHostData(1), DataVariable)
End Sub

' CallHost("SetVariable", "DestHostVarName,SrcScriptVarName")
Sub SetVariable
	DataVariable = BasicLib.GetGlobal(CallHostData(1))
	CallSub(SubModule & "." & SetVariableSub, CallHostData(0))
End Sub


' CallHost("CallSub", "SubAndParameters,DestScriptVarName")
Sub CallHost
	RetIndex = ArrayLen(CallHostData()) - 1
	Select ArrayLen(CallHostData())
		Case 1, 2
			Rtn = CallSub(SubModule & "." & CallHostData(0))
		Case 3
			Rtn = CallSub(SubModule & "." & CallHostData(0), CallHostData(1))
		Case 4
			Rtn = CallSub(SubModule & "." & CallHostData(0), CallHostData(1), CallHostData(2))
		Case 5
			Rtn = CallSub(SubModule & "." & CallHostData(0), CallHostData(1), CallHostData(2), CallHostData(3))
		Case Else
			Rtn = ""
		End Select
		BasicLib.SetGlobal(CallHostData(RetIndex), Rtn)
End Sub

' CallHost("Threaded", "DestScriptVarName")
Sub Threaded
	BasicLib.SetGlobal(CallHostData(0), OnThread)
End Sub



#Region script engine events

Sub BasicLib_CallHost
	' occurs when CallHost is executed
	DataVariable = ""
	Dim DataArray(0)
	CallHostData() = StrSplit(BasicLib.SubjectString, ",")
	Cmd = StrToLower(BasicLib.MessageString)
	Select Cmd
		Case "getarray"
			GetArray
		Case "setarray"
			SetArray
		Case "getvariable"
			GetVariable
		Case "setvariable"
			SetVariable
		Case "callsub"
			CallHost
		Case "fileread"
			HostFileRead
		Case "filewrite"
			HostFileWrite
		Case "filedel"
			HostFileDel
		Case "fileexist"
			HostFileExist			
		Case "dircreate"
			HostDirCreate
		Case "dirdel"
			HostDirDel
		Case "direxist"
			HostDirExist
		Case "threaded"
			Threaded
		Case Else
			Msgbox("Non-existent CallHost command - " & BasicLib.MessageString, "Script error")
	End Select
End Sub

Sub BasicLib_Ended
	' cccurs when the program terminates
	' within this event the GetXXX methods could be used to retrieve the contents of variables If required
	' BasicLib.ErrorString holds the error reason if not ""
	If BasicLib.ErrorString <> "" Then
		msg = "Error at line " & BasicLib.LineNumber & CRLF
		msg = msg & "Code - " & BasicLib.ProgramLine(BasicLib.LineNumber) 
		msg = msg & "Error - " & BasicLib.ErrorString 
	Else	
		msg = ""
	End If
	If EndedSub <> "" Then
		CallSub(SubModule & "." & EndedSub, BasicLib.ErrorString, msg)
	End If
End Sub

Sub BasicLib_Message
	' occurs when Msgbox or Print are executed
	' MessageString contains the first parameter of the MsgBox statement or the Printed string
	' SubjectString contains the second, optional, parameter of MsgBox or "Print" for a Print statement
	If MessageSub <> "" Then
		CallSub(SubModule & "." & MessageSub, BasicLib.MessageString, BasicLib.SubjectString)
	End If
End Sub

#End Region script engine events
